Bug 12884 - [4.0 only] error in reading a namelist when it is predeced by a line with a SLASH
Summary: [4.0 only] error in reading a namelist when it is predeced by a line with a S...
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: libfortran (show other bugs)
Version: 3.2
: P2 normal
Target Milestone: 4.0.1
Assignee: Toon Moene
URL:
Keywords:
Depends on: 14976
Blocks: 19292
  Show dependency treegraph
 
Reported: 2003-11-03 13:10 UTC by jean-pierre.flament
Modified: 2005-04-23 16:11 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2005-04-18 07:44:28


Attachments
comments, test program and test data (2.38 KB, text/plain)
2003-11-03 13:12 UTC, jean-pierre.flament
Details

Note You need to log in before you can comment on or make changes to this bug.
Description jean-pierre.flament 2003-11-03 13:10:40 UTC
in the follwing flow of data ($FILE is not a namelist)
 $FILE
   pseu  dir/file
 $END
 $CNTRL ispher=1,nosym=0,runflg=0,noprop=0, $END

the namelist $CNTRL is not read

 integer ispher,nosym,runflg,noprop
 ispher = 0
 nosym = 0
 runflg = 0
 noprop = 0 
 read(5,cntrl) 

 * gives a value of 0 instead of 1 for ispher

 * putting $CNTRL before the "group data" $FILE gives the correct result
   as well as inserting any line between the $END of $FILE and $CNTRL)
I guess that the / in dir/file is the reason of the problem.

I can provide you with a sample program and data reproducing the bug.
Comment 1 jean-pierre.flament 2003-11-03 13:12:39 UTC
Created attachment 5045 [details]
comments, test program and test data
Comment 2 Toon Moene 2003-11-15 12:41:58 UTC
Fails in 3.3 too. Actually a problem in libf2c, hence redirecting.
Comment 3 bdavis9659 2003-12-28 01:40:11 UTC
patch here   http://gcc.gnu.org/ml/gcc-patches/2003-12/msg02149.html
Comment 4 CVS Commits 2004-01-31 14:11:54 UTC
Subject: Bug 12884

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-3_4-branch
Changes by:	toon@gcc.gnu.org	2004-01-31 14:11:50

Modified files:
	libf2c         : ChangeLog 
	libf2c/libI77  : rsne.c 

Log message:
	2004-01-31  Bud Davis  <bdavis9659@comcast.net>
	
	PR fortran/12884
	* libI77/rsne.c: Enable reading a '/' when reading
	a '$' delimited namelist.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libf2c/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.202&r2=1.202.2.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libf2c/libI77/rsne.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.12&r2=1.12.36.1

Comment 5 CVS Commits 2004-01-31 14:15:06 UTC
Subject: Bug 12884

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-3_4-branch
Changes by:	toon@gcc.gnu.org	2004-01-31 14:15:00

Modified files:
	gcc/testsuite  : ChangeLog 
Added files:
	gcc/testsuite/g77.f-torture/execute: 12884.f 

Log message:
	2004-01-31  Bud Davis  <bdavis9659@comcast.net>
	
	PR fortran/12884
	* g77.f-torture/execute/12884.f: New test

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.3389.2.34&r2=1.3389.2.35
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g77.f-torture/execute/12884.f.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1

Comment 6 Toon Moene 2004-01-31 14:19:59 UTC
Fixed by Bud Davis' proposed patch, which I installed on 31/1/2004

Thanks, Bud !
Comment 7 andreasmeier80 2004-01-31 16:04:08 UTC
What about mainline?
Comment 8 Andrew Pinski 2004-01-31 18:19:42 UTC
Lets reopen this until the tree-ssa gets merged and just say this is a regression for now.
Comment 9 Andrew Pinski 2004-01-31 18:20:39 UTC
But lets suspend it then and wait and see about the tree-ssa merge.
Comment 10 Toon Moene 2004-09-09 18:34:40 UTC
Not clear yet why it fails with libgfortran; error message:

At line 13 of file 12884.f
Fortran runtime error: Invalid character in namelist

This is the test case I use:

      program nlist
      integer ispher,nosym,runflg,noprop
      namelist /cntrl/ ispher,nosym,runflg,noprop
      ispher = 0
      nosym = 0
      runflg = 0
      noprop = 0 
      write(1,*)' $FILE'
      write(1,*)'   pseu  dir/file'
      write(1,*)'  $END'
      write(1,*)' $CNTRL ispher=1,nosym=0,runflg=0,noprop=0, $END'
      rewind(1)
      read(1,cntrl)
      write(6,cntrl)
      end
Comment 11 Andrew Pinski 2004-09-24 04:09:38 UTC
Removing the patch keyword as the patch was only for libg2c which is not used for gfortran.
Comment 12 Francois-Xavier Coudert 2005-04-18 07:44:28 UTC
This is fixed by Paul's recent namelist patch, applied on mainline. Will be
fixed on 4.0 once it's reopened.
Comment 13 Paul Thomas 2005-04-23 16:11:08 UTC
The namelist modifications implemented over the last week have resulted in 
namelist io that is compliant with the standard and this bug is fixed, as of 
GCC 4.1.0 20050423.
Comment 14 CVS Commits 2005-06-05 23:34:23 UTC
Subject: Bug 12884

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-4_0-branch
Changes by:	tobi@gcc.gnu.org	2005-06-05 23:33:52

Modified files:
	gcc/fortran    : ChangeLog gfortran.texi trans-io.c 
	gcc/testsuite  : ChangeLog 
	gcc/testsuite/gfortran.dg: namelist_1.f90 
	libgfortran    : ChangeLog 
	libgfortran/io : io.h list_read.c lock.c transfer.c write.c 
Added files:
	gcc/testsuite/gfortran.dg: namelist_11.f namelist_12.f 
	                           namelist_13.f90 namelist_14.f90 
	                           namelist_15.f90 namelist_16.f90 
	                           namelist_17.f90 namelist_18.f90 
	                           namelist_19.f90 namelist_2.f90 
	                           namelist_20.f90 namelist_3.f90 
	                           pr12884.f pr17285.f90 pr17472.f 
	                           pr18122.f90 pr18210.f90 pr18392.f90 
	                           pr19467.f90 pr19657.f 

Log message:
	gcc/fortran/
	2005-06-05  Jakub Jelinek  <jakub@redhat.com>
	
	Backport from the mainline:
	2005-04-17 Paul Thomas <pault@gcc.gnu.org>
	
	PR fortran/17472
	PR fortran/18209
	PR fortran/18396
	PR fortran/19467
	PR fortran/19657
	* fortran/trans-io.c (gfc_build_io_library_fndecls): Create
	declaration for	st_set_nml_var and st_set_nml_var_dim. Remove
	declarations of old namelist functions.
	(build_dt): Simplified call to transfer_namelist_element.
	(nml_get_addr_expr): Generates address expression for start of
	object data. New function.
	(nml_full_name): Qualified name for derived type components. New
	function.
	(transfer_namelist_element): Modified for calls to new functions
	and improved derived type handling.
	
	libgfortran/
	2005-06-05  Jakub Jelinek  <jakub@redhat.com>
	
	Backport from the mainline:
	2005-04-18 Paul Thomas <pault@gcc.gnu.org>
	Jerry DeLisle <jvdelisle@verizon.net>
	
	* io/write.c (nml_write_obj): Provide 1 more byte for ext_name.
	* io/list_read.c (nml_get_obj_data): Put extra brackets in get_mem
	call for ext_name.  These fix the bug reported by Jerry DeLisle to
	the fortran list and are based on his suggested fix.
	
	2005-04-18 Paul Thomas <pault@gcc.gnu.org>
	
	* io/list_read.c (nml_touch_nodes, nml_read_obj,
	nml_get_obj_data): Fix memory leaks in code for derived types.
	
	2005-04-17 Paul Thomas <pault@gcc.gnu.org>
	
	* io/list_read.c (eat_separator): at_eol = 1 replaced
	(zapped at some time?).
	
	2005-04-17 Paul Thomas <pault@gcc.gnu.org>
	
	PR libgfortran/12884
	PR libgfortran/17285
	PR libgfortran/18122
	PR libgfortran/18210
	PR libgfortran/18392
	PR libgfortran/18591
	PR libgfortran/18879
	* io/io.h (nml_ls): Declare.
	(namelist_info): Modify for arrays.
	* io/list_read.c (namelist_read): Reduced to call to new functions.
	(match_namelist_name): Simplified.
	(nml_query): Handles stdin queries ? and =?. New function.
	(nml_get_obj_data): Parses object name. New function.
	(touch_nml_nodes): Marks objects for read. New function.
	(untouch_nml_nodes): Resets objects. New function.
	(parse_qualifier): Parses and checks qualifiers. New function
	(nml_read_object): Reads and stores object data. New function.
	(eat_separator): No new_record on '/' in namelist.
	(finish_separator): No new_record on '/' in namelist.
	(read_logical): Error return for namelist.
	(read_integer): Error return for namelist.
	(read_complex): Error return for namelist.
	(read_real): Error return for namelist.
	* io/lock.c (library_end): Free extended namelist_info types.
	* io/transfer.c (st_set_nml_var): Modified for arrays.
	(st_set_nml_var_dim): Dimension descriptors. New function.
	* io/write.c (namelist_write): Reduced to call to new functions.
	(nml_write_obj): Writes output for object. New function.
	(write_integer): Suppress leading blanks for repeat counts.
	(write_int): Suppress leading blanks for repeat counts.
	(write_float): Suppress leading blanks for repeat counts.
	(output_float): Suppress leading blanks for repeat counts.
	
	gcc/testsuite/
	2005-06-05  Jakub Jelinek  <jakub@redhat.com>
	
	Backport from the mainline:
	2005-04-17 Paul Thomas <pault@gcc.gnu.org>
	
	PR fortran/17472
	PR fortran/18209
	PR fortran/18396
	PR fortran/19467
	PR fortran/19657
	* fortran/trans-io.c (gfc_build_io_library_fndecls): Create
	declaration for	st_set_nml_var and st_set_nml_var_dim. Remove
	declarations of old namelist functions.
	(build_dt): Simplified call to transfer_namelist_element.
	(nml_get_addr_expr): Generates address expression for start of
	object data. New function.
	(nml_full_name): Qualified name for derived type components. New
	function.
	(transfer_namelist_element): Modified for calls to new functions
	and improved derived type handling.
	
	PR libfortran/12884 gfortran.dg/pr12884.f: New test
	PR libfortran/17285 gfortran.dg/pr17285.f90: New test
	PR libfortran/17472, 18396, 18209 gfortran.dg/pr17472.f: New test
	PR libfortran/18122, 18591 gfortran.dg/pr18122.f90: New test
	PR libfortran/18210 gfortran.dg/pr18210.f90: New test
	PR libfortran/18392 gfortran.dg/pr18392.f90: New test
	PR libfortran/19467 gfortran.dg/pr19467.f90: New test
	PR libfortran/19657 gfortran.dg/pr19657.f90: New test
	* gfortran.dg/namelist_1.f90: Correct comment (PUBLIC and PRIVATE wrong way round).
	* gfortran.dg/namelist_2.f90: Variables with INTENT(IN) cannot be in namelists. New test
	* gfortran.dg/namelist_3.f90: Pointers cannot be in namelists. New test
	* gfortran.dg/namelist_11.f: Tests reals and qualifiers in namelist. New test
	* gfortran.dg/namelist_12.f: Tests integers and qualifiers in namelist. New test
	* gfortran.dg/namelist_13.f90: Tests derived types in namelist. New test
	* gfortran.dg/namelist_14.f90: Tests trans-io.c namelist support. New test
	* gfortran.dg/namelist_15.f90: Tests arrays of derived types in namelist. New test
	* gfortran.dg/namelist_16.f90: Tests complex in namelist. New test
	* gfortran.dg/namelist_17.f90: Tests logical in namelist. New test
	* gfortran.dg/namelist_18.f90: Tests charcter delimiters in namelist. New test
	* gfortran.dg/namelist_19.f90: Tests namelist errors. New test
	* gfortran.dg/namelist_20.f90: Tests negative bounds for explicit arrays. New test

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/fortran/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.335.2.70&r2=1.335.2.71
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/fortran/gfortran.texi.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.10.8.2&r2=1.10.8.3
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/fortran/trans-io.c.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.33.2.2&r2=1.33.2.3
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.5084.2.233&r2=1.5084.2.234
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_11.f.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_12.f.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_13.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_14.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_15.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_16.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_17.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_18.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_19.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_2.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_20.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_3.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/pr12884.f.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/pr17285.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/pr17472.f.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/pr18122.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/pr18210.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/pr18392.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/pr19467.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/pr19657.f.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.6.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gfortran.dg/namelist_1.f90.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.1&r2=1.1.18.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libgfortran/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.163.2.47&r2=1.163.2.48
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libgfortran/io/io.h.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.16.10.1&r2=1.16.10.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libgfortran/io/list_read.c.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.14.2.1&r2=1.14.2.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libgfortran/io/lock.c.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.5&r2=1.5.12.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libgfortran/io/transfer.c.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.32.2.4&r2=1.32.2.5
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libgfortran/io/write.c.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.23.2.7&r2=1.23.2.8